<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfString ArrayType
 * @subpackage Arrays
 */
class ArrayOfString extends AbstractStructArrayBase
{
    /**
     * The gtin
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $gtin;
    /**
     * Constructor method for ArrayOfString
     * @uses ArrayOfString::setGtin()
     * @param string[] $gtin
     */
    public function __construct(array $gtin = array())
    {
        $this
            ->setGtin($gtin);
    }
    /**
     * Get gtin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getGtin()
    {
        return isset($this->gtin) ? $this->gtin : null;
    }
    /**
     * Set gtin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $gtin
     * @return \ArrayType\ArrayOfString
     */
    public function setGtin(array $gtin = array())
    {
        foreach ($gtin as $arrayOfStringGtinItem) {
            // validation for constraint: itemType
            if (!is_string($arrayOfStringGtinItem)) {
                throw new \InvalidArgumentException(sprintf('The gtin property can only contain items of string, "%s" given', is_object($arrayOfStringGtinItem) ? get_class($arrayOfStringGtinItem) : gettype($arrayOfStringGtinItem)), __LINE__);
            }
        }
        if (is_null($gtin) || (is_array($gtin) && empty($gtin))) {
            unset($this->gtin);
        } else {
            $this->gtin = $gtin;
        }
        return $this;
    }
    /**
     * Add item to gtin value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfString
     */
    public function addToGtin($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The gtin property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->gtin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string gtin
     */
    public function getAttributeName()
    {
        return 'gtin';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfString
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
